# Copyright 2013 the V8 project authors. All rights reserved.
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are
# met:
#
#     * Redistributions of source code must retain the above copyright
#       notice, this list of conditions and the following disclaimer.
#     * Redistributions in binary form must reproduce the above
#       copyright notice, this list of conditions and the following
#       disclaimer in the documentation and/or other materials provided
#       with the distribution.
#     * Neither the name of Google Inc. nor the names of its
#       contributors may be used to endorse or promote products derived
#       from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

# This file is automatically generated from the V8 source and should not
# be modified manually, run 'make grokdump' instead to update this file.

# List of known V8 instance types.
INSTANCE_TYPES = {
  64: "STRING_TYPE",
  68: "ONE_BYTE_STRING_TYPE",
  65: "CONS_STRING_TYPE",
  69: "CONS_ONE_BYTE_STRING_TYPE",
  67: "SLICED_STRING_TYPE",
  71: "SLICED_ONE_BYTE_STRING_TYPE",
  66: "EXTERNAL_STRING_TYPE",
  70: "EXTERNAL_ONE_BYTE_STRING_TYPE",
  74: "EXTERNAL_STRING_WITH_ONE_BYTE_DATA_TYPE",
  82: "SHORT_EXTERNAL_STRING_TYPE",
  86: "SHORT_EXTERNAL_ONE_BYTE_STRING_TYPE",
  90: "SHORT_EXTERNAL_STRING_WITH_ONE_BYTE_DATA_TYPE",
  0: "INTERNALIZED_STRING_TYPE",
  4: "ONE_BYTE_INTERNALIZED_STRING_TYPE",
  2: "EXTERNAL_INTERNALIZED_STRING_TYPE",
  6: "EXTERNAL_ONE_BYTE_INTERNALIZED_STRING_TYPE",
  10: "EXTERNAL_INTERNALIZED_STRING_WITH_ONE_BYTE_DATA_TYPE",
  18: "SHORT_EXTERNAL_INTERNALIZED_STRING_TYPE",
  22: "SHORT_EXTERNAL_ONE_BYTE_INTERNALIZED_STRING_TYPE",
  26: "SHORT_EXTERNAL_INTERNALIZED_STRING_WITH_ONE_BYTE_DATA_TYPE",
  128: "SYMBOL_TYPE",
  129: "MAP_TYPE",
  130: "CODE_TYPE",
  131: "ODDBALL_TYPE",
  132: "CELL_TYPE",
  133: "PROPERTY_CELL_TYPE",
  134: "HEAP_NUMBER_TYPE",
  135: "MUTABLE_HEAP_NUMBER_TYPE",
  136: "FOREIGN_TYPE",
  137: "BYTE_ARRAY_TYPE",
  138: "FREE_SPACE_TYPE",
  139: "EXTERNAL_INT8_ARRAY_TYPE",
  140: "EXTERNAL_UINT8_ARRAY_TYPE",
  141: "EXTERNAL_INT16_ARRAY_TYPE",
  142: "EXTERNAL_UINT16_ARRAY_TYPE",
  143: "EXTERNAL_INT32_ARRAY_TYPE",
  144: "EXTERNAL_UINT32_ARRAY_TYPE",
  145: "EXTERNAL_FLOAT32_ARRAY_TYPE",
  146: "EXTERNAL_FLOAT64_ARRAY_TYPE",
  147: "EXTERNAL_UINT8_CLAMPED_ARRAY_TYPE",
  148: "FIXED_INT8_ARRAY_TYPE",
  149: "FIXED_UINT8_ARRAY_TYPE",
  150: "FIXED_INT16_ARRAY_TYPE",
  151: "FIXED_UINT16_ARRAY_TYPE",
  152: "FIXED_INT32_ARRAY_TYPE",
  153: "FIXED_UINT32_ARRAY_TYPE",
  154: "FIXED_FLOAT32_ARRAY_TYPE",
  155: "FIXED_FLOAT64_ARRAY_TYPE",
  156: "FIXED_UINT8_CLAMPED_ARRAY_TYPE",
  158: "FILLER_TYPE",
  159: "DECLARED_ACCESSOR_DESCRIPTOR_TYPE",
  160: "DECLARED_ACCESSOR_INFO_TYPE",
  161: "EXECUTABLE_ACCESSOR_INFO_TYPE",
  162: "ACCESSOR_PAIR_TYPE",
  163: "ACCESS_CHECK_INFO_TYPE",
  164: "INTERCEPTOR_INFO_TYPE",
  165: "CALL_HANDLER_INFO_TYPE",
  166: "FUNCTION_TEMPLATE_INFO_TYPE",
  167: "OBJECT_TEMPLATE_INFO_TYPE",
  168: "SIGNATURE_INFO_TYPE",
  169: "TYPE_SWITCH_INFO_TYPE",
  171: "ALLOCATION_MEMENTO_TYPE",
  170: "ALLOCATION_SITE_TYPE",
  172: "SCRIPT_TYPE",
  173: "CODE_CACHE_TYPE",
  174: "POLYMORPHIC_CODE_CACHE_TYPE",
  175: "TYPE_FEEDBACK_INFO_TYPE",
  176: "ALIASED_ARGUMENTS_ENTRY_TYPE",
  177: "BOX_TYPE",
  180: "FIXED_ARRAY_TYPE",
  157: "FIXED_DOUBLE_ARRAY_TYPE",
  181: "CONSTANT_POOL_ARRAY_TYPE",
  182: "SHARED_FUNCTION_INFO_TYPE",
  183: "WEAK_CELL_TYPE",
  187: "JS_MESSAGE_OBJECT_TYPE",
  186: "JS_VALUE_TYPE",
  188: "JS_DATE_TYPE",
  189: "JS_OBJECT_TYPE",
  190: "JS_CONTEXT_EXTENSION_OBJECT_TYPE",
  191: "JS_GENERATOR_OBJECT_TYPE",
  192: "JS_MODULE_TYPE",
  193: "JS_GLOBAL_OBJECT_TYPE",
  194: "JS_BUILTINS_OBJECT_TYPE",
  195: "JS_GLOBAL_PROXY_TYPE",
  196: "JS_ARRAY_TYPE",
  197: "JS_ARRAY_BUFFER_TYPE",
  198: "JS_TYPED_ARRAY_TYPE",
  199: "JS_DATA_VIEW_TYPE",
  185: "JS_PROXY_TYPE",
  200: "JS_SET_TYPE",
  201: "JS_MAP_TYPE",
  202: "JS_SET_ITERATOR_TYPE",
  203: "JS_MAP_ITERATOR_TYPE",
  204: "JS_WEAK_MAP_TYPE",
  205: "JS_WEAK_SET_TYPE",
  206: "JS_REGEXP_TYPE",
  207: "JS_FUNCTION_TYPE",
  184: "JS_FUNCTION_PROXY_TYPE",
  178: "DEBUG_INFO_TYPE",
  179: "BREAK_POINT_INFO_TYPE",
}

# List of known V8 maps.
KNOWN_MAPS = {
  0x08081: (137, "ByteArrayMap"),
  0x080ad: (129, "MetaMap"),
  0x080d9: (131, "NullMap"),
  0x08105: (180, "FixedArrayMap"),
  0x08131: (4, "OneByteInternalizedStringMap"),
  0x0815d: (183, "WeakCellMap"),
  0x08189: (131, "UndefinedMap"),
  0x081b5: (134, "HeapNumberMap"),
  0x081e1: (138, "FreeSpaceMap"),
  0x0820d: (158, "OnePointerFillerMap"),
  0x08239: (158, "TwoPointerFillerMap"),
  0x08265: (131, "TheHoleMap"),
  0x08291: (131, "BooleanMap"),
  0x082bd: (131, "UninitializedMap"),
  0x082e9: (131, "ExceptionMap"),
  0x08315: (132, "CellMap"),
  0x08341: (133, "GlobalPropertyCellMap"),
  0x0836d: (182, "SharedFunctionInfoMap"),
  0x08399: (135, "MutableHeapNumberMap"),
  0x083c5: (180, "NativeContextMap"),
  0x083f1: (130, "CodeMap"),
  0x0841d: (180, "ScopeInfoMap"),
  0x08449: (180, "FixedCOWArrayMap"),
  0x08475: (157, "FixedDoubleArrayMap"),
  0x084a1: (181, "ConstantPoolArrayMap"),
  0x084cd: (131, "NoInterceptorResultSentinelMap"),
  0x084f9: (180, "HashTableMap"),
  0x08525: (180, "OrderedHashTableMap"),
  0x08551: (131, "ArgumentsMarkerMap"),
  0x0857d: (131, "TerminationExceptionMap"),
  0x085a9: (128, "SymbolMap"),
  0x085d5: (64, "StringMap"),
  0x08601: (68, "OneByteStringMap"),
  0x0862d: (65, "ConsStringMap"),
  0x08659: (69, "ConsOneByteStringMap"),
  0x08685: (67, "SlicedStringMap"),
  0x086b1: (71, "SlicedOneByteStringMap"),
  0x086dd: (66, "ExternalStringMap"),
  0x08709: (74, "ExternalStringWithOneByteDataMap"),
  0x08735: (70, "ExternalOneByteStringMap"),
  0x08761: (70, "NativeSourceStringMap"),
  0x0878d: (82, "ShortExternalStringMap"),
  0x087b9: (90, "ShortExternalStringWithOneByteDataMap"),
  0x087e5: (0, "InternalizedStringMap"),
  0x08811: (2, "ExternalInternalizedStringMap"),
  0x0883d: (10, "ExternalInternalizedStringWithOneByteDataMap"),
  0x08869: (6, "ExternalOneByteInternalizedStringMap"),
  0x08895: (18, "ShortExternalInternalizedStringMap"),
  0x088c1: (26, "ShortExternalInternalizedStringWithOneByteDataMap"),
  0x088ed: (22, "ShortExternalOneByteInternalizedStringMap"),
  0x08919: (86, "ShortExternalOneByteStringMap"),
  0x08945: (139, "ExternalInt8ArrayMap"),
  0x08971: (140, "ExternalUint8ArrayMap"),
  0x0899d: (141, "ExternalInt16ArrayMap"),
  0x089c9: (142, "ExternalUint16ArrayMap"),
  0x089f5: (143, "ExternalInt32ArrayMap"),
  0x08a21: (144, "ExternalUint32ArrayMap"),
  0x08a4d: (145, "ExternalFloat32ArrayMap"),
  0x08a79: (146, "ExternalFloat64ArrayMap"),
  0x08aa5: (147, "ExternalUint8ClampedArrayMap"),
  0x08ad1: (149, "FixedUint8ArrayMap"),
  0x08afd: (148, "FixedInt8ArrayMap"),
  0x08b29: (151, "FixedUint16ArrayMap"),
  0x08b55: (150, "FixedInt16ArrayMap"),
  0x08b81: (153, "FixedUint32ArrayMap"),
  0x08bad: (152, "FixedInt32ArrayMap"),
  0x08bd9: (154, "FixedFloat32ArrayMap"),
  0x08c05: (155, "FixedFloat64ArrayMap"),
  0x08c31: (156, "FixedUint8ClampedArrayMap"),
  0x08c5d: (180, "SloppyArgumentsElementsMap"),
  0x08c89: (180, "FunctionContextMap"),
  0x08cb5: (180, "CatchContextMap"),
  0x08ce1: (180, "WithContextMap"),
  0x08d0d: (180, "BlockContextMap"),
  0x08d39: (180, "ModuleContextMap"),
  0x08d65: (180, "ScriptContextMap"),
  0x08d91: (180, "ScriptContextTableMap"),
  0x08dbd: (187, "JSMessageObjectMap"),
  0x08de9: (136, "ForeignMap"),
  0x08e15: (189, "NeanderMap"),
  0x08e41: (189, "ExternalMap"),
  0x08e6d: (170, "AllocationSiteMap"),
  0x08e99: (171, "AllocationMementoMap"),
  0x08ec5: (174, "PolymorphicCodeCacheMap"),
  0x08ef1: (172, "ScriptMap"),
  0x0907d: (177, "BoxMap"),
  0x090a9: (161, "ExecutableAccessorInfoMap"),
  0x090d5: (162, "AccessorPairMap"),
  0x09101: (163, "AccessCheckInfoMap"),
  0x0912d: (164, "InterceptorInfoMap"),
  0x09159: (165, "CallHandlerInfoMap"),
  0x09185: (166, "FunctionTemplateInfoMap"),
  0x091b1: (167, "ObjectTemplateInfoMap"),
  0x091dd: (169, "TypeSwitchInfoMap"),
  0x09209: (173, "CodeCacheMap"),
  0x09235: (175, "TypeFeedbackInfoMap"),
  0x09261: (176, "AliasedArgumentsEntryMap"),
  0x0928d: (178, "DebugInfoMap"),
  0x092b9: (179, "BreakPointInfoMap"),
}

# List of known V8 objects.
KNOWN_OBJECTS = {
  ("OLD_SPACE", 0x08081): "NullValue",
  ("OLD_SPACE", 0x08091): "EmptyDescriptorArray",
  ("OLD_SPACE", 0x08099): "EmptyFixedArray",
  ("OLD_SPACE", 0x080bd): "UndefinedValue",
  ("OLD_SPACE", 0x080e5): "NanValue",
  ("OLD_SPACE", 0x080f1): "TheHoleValue",
  ("OLD_SPACE", 0x08111): "TrueValue",
  ("OLD_SPACE", 0x08131): "FalseValue",
  ("OLD_SPACE", 0x08155): "UninitializedValue",
  ("OLD_SPACE", 0x08181): "Exception",
  ("OLD_SPACE", 0x081a9): "NoInterceptorResultSentinel",
  ("OLD_SPACE", 0x081e5): "EmptyByteArray",
  ("OLD_SPACE", 0x081ed): "EmptyConstantPoolArray",
  ("OLD_SPACE", 0x081fd): "ArgumentsMarker",
  ("OLD_SPACE", 0x08229): "NumberStringCache",
  ("OLD_SPACE", 0x08a31): "SingleCharacterStringCache",
  ("OLD_SPACE", 0x08ec9): "StringSplitCache",
  ("OLD_SPACE", 0x092d1): "RegExpMultipleCache",
  ("OLD_SPACE", 0x096d9): "TerminationException",
  ("OLD_SPACE", 0x0970d): "EmptyExternalInt8Array",
  ("OLD_SPACE", 0x09719): "EmptyExternalUint8Array",
  ("OLD_SPACE", 0x09725): "EmptyExternalInt16Array",
  ("OLD_SPACE", 0x09731): "EmptyExternalUint16Array",
  ("OLD_SPACE", 0x0973d): "EmptyExternalInt32Array",
  ("OLD_SPACE", 0x09749): "EmptyExternalUint32Array",
  ("OLD_SPACE", 0x09755): "EmptyExternalFloat32Array",
  ("OLD_SPACE", 0x09761): "EmptyExternalFloat64Array",
  ("OLD_SPACE", 0x0976d): "EmptyExternalUint8ClampedArray",
  ("OLD_SPACE", 0x09779): "EmptyFixedUint8Array",
  ("OLD_SPACE", 0x09781): "EmptyFixedInt8Array",
  ("OLD_SPACE", 0x09789): "EmptyFixedUint16Array",
  ("OLD_SPACE", 0x09791): "EmptyFixedInt16Array",
  ("OLD_SPACE", 0x09799): "EmptyFixedUint32Array",
  ("OLD_SPACE", 0x097a1): "EmptyFixedInt32Array",
  ("OLD_SPACE", 0x097a9): "EmptyFixedFloat32Array",
  ("OLD_SPACE", 0x097b1): "EmptyFixedFloat64Array",
  ("OLD_SPACE", 0x097b9): "EmptyFixedUint8ClampedArray",
  ("OLD_SPACE", 0x097c1): "InfinityValue",
  ("OLD_SPACE", 0x097cd): "MinusZeroValue",
  ("OLD_SPACE", 0x097d9): "MessageListeners",
  ("OLD_SPACE", 0x097f5): "CodeStubs",
  ("OLD_SPACE", 0x12c49): "NonMonomorphicCache",
  ("OLD_SPACE", 0x132bd): "PolymorphicCodeCache",
  ("OLD_SPACE", 0x132c5): "NativesSourceCache",
  ("OLD_SPACE", 0x1353d): "EmptyScript",
  ("OLD_SPACE", 0x13585): "IntrinsicFunctionNames",
  ("OLD_SPACE", 0x27ae5): "ObservationState",
  ("OLD_SPACE", 0x27af1): "SymbolRegistry",
  ("OLD_SPACE", 0x2863d): "EmptySlowElementDictionary",
  ("OLD_SPACE", 0x287d9): "AllocationSitesScratchpad",
  ("OLD_SPACE", 0x28be1): "WeakObjectToCodeTable",
  ("OLD_SPACE", 0x4e9dd): "StringTable",
  ("CODE_SPACE", 0x15f61): "JsEntryCode",
  ("CODE_SPACE", 0x24781): "JsConstructEntryCode",
}
